OGRE: Ogre::RTShader Namespace Reference

| OGRE 2.2.4 Object-Oriented Graphics Rendering Engine

Classes | Typedefs | Enumerations | Functions
Ogre::RTShader Namespace Reference

## Classes
class | CGProgramProcessor
| CG Language program processor class. More...
class | CGProgramWriter
| CG target language writer implementation. More...
struct | CompareUniformByName
class | ConstParameter
| Helper template which is the base for our ConstParameters. More...
class | DualQuaternionSkinning
| Implement a sub render state which performs dual quaternion hardware skinning. More...
class | FFPAlphaTest
| A factory that enables creation of LayeredBlending instances. More...
class | FFPAlphaTestFactory
class | FFPColour
| Colour sub render state implementation of the Fixed Function Pipeline. More...
class | FFPColourFactory
| A factory that enables creation of FFPColour instances. More...
class | FFPFog
| Fog sub render state implementation of the Fixed Function Pipeline. More...
class | FFPFogFactory
| A factory that enables creation of FFPFog instances. More...
class | FFPLighting
| Lighting sub render state implementation of the Fixed Function Pipeline. More...
class | FFPLightingFactory
| A factory that enables creation of FFPLighting instances. More...
class | FFPRenderStateBuilder
| Fixed Function Pipeline render state builder. More...
class | FFPTexturing
| Texturing sub render state implementation of the Fixed Function Pipeline. More...
class | FFPTexturingFactory
| A factory that enables creation of FFPTexturing instances. More...
class | FFPTransform
| Transform sub render state implementation of the Fixed Function Pipeline. More...
class | FFPTransformFactory
| A factory that enables creation of FFPTransform instances. More...
class | Function
| A class that represents a shader based program function. More...
class | FunctionAtom
| A class that represents an atomic code section of shader based program function. More...
class | FunctionInvocation
| A class that represents function invocation code from shader based program function. More...
class | GLSLESProgramProcessor
| GLSL ES Language program processor class. More...
class | GLSLESProgramWriter
| GLSL ES target language writer implementation. More...
class | GLSLProgramProcessor
| GLSL Language program processor class. More...
class | GLSLProgramWriter
| GLSL target language writer implementation. More...
class | HardwareSkinning
| Implement a sub render state which performs hardware skinning. More...
class | HardwareSkinningFactory
| A factory that enables creation of HardwareSkinning instances. More...
class | HardwareSkinningTechnique
| Implement a sub render state which performs hardware skinning. More...
class | HLSLProgramProcessor
| CG Language program processor class. More...
class | HLSLProgramWriter
| HLSL target language writer implementation. More...
class | IntegratedPSSM3
| Integrated PSSM shadow receiver with 3 splits sub render state implementation. More...
class | IntegratedPSSM3Factory
| A factory that enables creation of IntegratedPSSM3 instances. More...
class | LayeredBlending
| Texturing sub render state implementation of layered blending. More...
class | LayeredBlendingFactory
| A factory that enables creation of LayeredBlending instances. More...
class | LinearSkinning
| Implement a sub render state which performs hardware skinning. More...
class | NormalMapLighting
| Normal Map Lighting extension sub render state implementation. More...
class | NormalMapLightingFactory
| A factory that enables creation of NormalMapLighting instances. More...
class | Operand
| A class that represents a function operand (its the combination of a parameter the in/out semantic and the used fields) More...
class | Parameter
| A class that represents a shader based program parameter. More...
class | ParameterFactory
| Helper utility class that creates common parameters. More...
class | PerPixelLighting
| Per pixel Lighting extension sub render state implementation. More...
class | PerPixelLightingFactory
| A factory that enables creation of PerPixelLighting instances. More...
class | Program
| A class that represents a shader based program. More...
class | ProgramManager
| A singleton manager class that manages shader based programs. More...
class | ProgramProcessor
| A class that provides extra processing services on CPU based programs. More...
class | ProgramSet
| Container class for shader based programs. More...
class | ProgramWriter
| Base class interface for shader program writers. More...
class | ProgramWriterFactory
| Interface definition for factories of ShaderProgramWriter. More...
class | ProgramWriterManager
class | RenderState
| This is a container class for sub render state class. More...
class | SGMaterialSerializerListener
| This class responsible for translating core features of the RT Shader System for Ogre material scripts. More...
class | SGScriptTranslator
| This class responsible for translating core features of the RT Shader System for Ogre material scripts. More...
class | ShaderGenerator
| Shader generator system main interface. More...
class | ShaderProgramWriterCGFactory
| CG program writer factory implementation. More...
class | ShaderProgramWriterGLSLESFactory
| GLSL ES program writer factory implementation. More...
class | ShaderProgramWriterGLSLFactory
| GLSL program writer factory implementation. More...
class | ShaderProgramWriterHLSLFactory
| HLSL program writer factory implementation. More...
class | SubRenderState
| This class is the base interface of sub part from a shader based rendering pipeline. More...
class | SubRenderStateAccessor
| This class uses as accessor from a template SubRenderState to all of its instances that created based on it. More...
class | SubRenderStateFactory
| Abstract factory interface for creating SubRenderState implementation instances. More...
class | TargetRenderState
| This is the target render state. More...
struct | TextureAtlasRecord
class | TextureAtlasSampler
| Implements texture atlas sampling. More...
class | TextureAtlasSamplerFactory
| A factory that enables creation of TextureAtlasSampler instances. More...
class | TriplanarTexturing
| Triplanar Texturing. More...
class | TriplanarTexturingFactory
| A factory that enables creation of TriplanarMapping instances. More...
class | UniformParameter
| Uniform parameter class. More...

## Typedefs
typedef FunctionAtomInstanceList::const_iterator | FunctionAtomInstanceConstIterator
typedef FunctionAtomInstanceList::iterator | FunctionAtomInstanceIterator
typedef vector< FunctionAtom * >::type | FunctionAtomInstanceList
typedef SharedPtr< Parameter > | ParameterPtr
typedef RenderStateList::const_iterator | RenderStateConstIterator
typedef RenderStateList::iterator | RenderStateIterator
typedef vector< RenderState * >::type | RenderStateList
typedef ShaderFunctionList::const_iterator | ShaderFunctionConstIterator
typedef ShaderFunctionList::iterator | ShaderFunctionIterator
typedef vector< Function * >::type | ShaderFunctionList
typedef ShaderParameterList::const_iterator | ShaderParameterConstIterator
typedef ShaderParameterList::iterator | ShaderParameterIterator
typedef vector< ParameterPtr >::type | ShaderParameterList
typedef SharedPtr< SubRenderStateAccessor > | SubRenderStateAccessorPtr
typedef vector< SubRenderState * >::type | SubRenderStateList
typedef SubRenderStateList::const_iterator | SubRenderStateListConstIterator
typedef SubRenderStateList::iterator | SubRenderStateListIterator
typedef set< SubRenderState * >::type | SubRenderStateSet
typedef SubRenderStateSet::const_iterator | SubRenderStateSetConstIterator
typedef SubRenderStateSet::iterator | SubRenderStateSetIterator
typedef map< String, TextureAtlasTablePtr >::type | TextureAtlasMap
typedef vector< TextureAtlasRecord >::type | TextureAtlasTable
typedef SharedPtr< TextureAtlasTable > | TextureAtlasTablePtr
typedef UniformParameterList::const_iterator | UniformParameterConstIterator
typedef UniformParameterList::iterator | UniformParameterIterator
typedef vector< UniformParameterPtr >::type | UniformParameterList
typedef SharedPtr< UniformParameter > | UniformParameterPtr

## Enumerations
enum | FFPFragmentShaderStage { FFP_PS_PRE_PROCESS = 0, FFP_PS_COLOUR_BEGIN = 100, FFP_PS_SAMPLING = 150, FFP_PS_TEXTURING = 200, FFP_PS_COLOUR_END = 300, FFP_PS_FOG = 400, FFP_PS_POST_PROCESS = 500, FFP_PS_ALPHA_TEST = 1000 }
enum | FFPShaderStage { FFP_PRE_PROCESS = 0, FFP_TRANSFORM = 100, FFP_COLOUR = 200, FFP_LIGHTING = 300, FFP_TEXTURING = 400, FFP_FOG = 500, FFP_POST_PROCESS = 600, FFP_ALPHA_TEST = 1000 }
enum | FFPVertexShaderStage { FFP_VS_PRE_PROCESS = 0, FFP_VS_TRANSFORM = 100, FFP_VS_COLOUR = 200, FFP_VS_LIGHTING = 300, FFP_VS_TEXTURING = 400, FFP_VS_FOG = 500, FFP_VS_POST_PROCESS = 2000 }
enum | SkinningType { ST_LINEAR, ST_DUAL_QUATERNION }
enum | VSOutputCompactPolicy { VSOCP_LOW = 0, VSOCP_MEDIUM = 1, VSOCP_HIGH = 2 }

## Functions
_OgreRTSSExport void | operator<< (std::ostream &o, const HardwareSkinning::SkinningData &data)
_OgreRTSSExport void | operator<< (std::ostream &o, const TextureAtlasSamplerFactory::TextureAtlasAttib &tai)
template<class T >
void | sh_hash_combine (uint32 &seed, T const &v)
| Utility function with same style as boost::hash_combine. More...

## Typedef Documentation

## ◆ ParameterPtr

typedef SharedPtr<Parameter> Ogre::RTShader::ParameterPtr

## ◆ ShaderParameterList

typedef vector<ParameterPtr>::type Ogre::RTShader::ShaderParameterList

## ◆ UniformParameterPtr

typedef SharedPtr<UniformParameter> Ogre::RTShader::UniformParameterPtr

## Enumeration Type Documentation

## ◆ SkinningType

enum Ogre::RTShader::SkinningType

Enumerator
ST_LINEAR |
ST_DUAL_QUATERNION |

## ◆ VSOutputCompactPolicy

enum Ogre::RTShader::VSOutputCompactPolicy

Enumerator
VSOCP_LOW |
VSOCP_MEDIUM |
VSOCP_HIGH |

## Function Documentation

## ◆ sh_hash_combine()

template<class T >

void Ogre::RTShader::sh_hash_combine | ( | uint32 & | seed,
|  | T const & | v
| ) |  |
| inline

Utility function with same style as boost::hash_combine.

References Ogre::FastHash().